#include <stdio.h>
#include <stdlib.h>
#include <string.h>



static char typename_tbl[][4] = {
	"N",
	"B2",
	"SB",
	"GS",
	"88",
};


static unsigned int get_word(unsigned char *p){
	return (p[0] | (p[1] << 8));
}

static unsigned long get_dword(unsigned char *p){
	return (p[0] | (p[1] << 8) | (p[2] << 16) | (p[3] << 24));
}



int main(int argc, char *argv[]){
	FILE *fi;
	unsigned long ofs_tbl[8];
	unsigned long size;
	int num;
	


	if(2 > argc){
		printf("mf2_cut.exe [infile]\n");
		exit(0);
	}



	fi = fopen(argv[1], "rb");
	if(NULL == fi){
		printf("t@C݂܂ (%s)\n", argv[1]);
		exit(1);
	}

	fseek(fi, 0, SEEK_END);
	size = ftell(fi);

	{
		unsigned char buf[8];
		unsigned long t;

		fseek(fi, 0, SEEK_SET);
		fread(buf, 1, 4, fi);
		t = get_dword(buf);
		if(0 != (t & 7)){
			fclose(fi);
			printf("MF2 ł͂܂ (%s)\n", argv[1]);
			exit(1);
		}
		num = (t / 8);
		if(7 < num){
			fclose(fi);
			printf("MF2 ł͂܂ (%s)\n", argv[1]);
			exit(1);
		}
	}

	fseek(fi, 0, SEEK_SET);
	{
		unsigned char buf[8];
		unsigned long t;
		int k;

		for(k = 0; num > k; ++k){
			fread(buf, 1, 4, fi);
			t = get_dword(buf);
			if(size <= t){
				fclose(fi);
				printf("MF2 ł͂܂ (%s)\n", argv[1]);
				exit(1);
			}
			ofs_tbl[k] = t;
			fread(buf, 1, 4, fi);
			t = get_dword(buf);
			if(0 != t){
				fclose(fi);
				printf("MF2 ł͂܂ (%s)\n", argv[1]);
				exit(1);
			}
		}
		ofs_tbl[k] = size;
	}


	{
		unsigned long t_size;
		void *t_buf;
		char t_name[64];
		char b_name[64];
		FILE *fo;
		int k;

		{
			char *p;
			strcpy(b_name, argv[1]);
			p = strrchr(b_name, '.');
			if(p != NULL){
				if('\\' != p[1]){
					p[0] = '\0';
				}
			}
		}

		for(k = 0; num > k; ++k){
			t_size = (ofs_tbl[k + 1] - ofs_tbl[k]);
			t_buf = malloc(t_size);
			if(NULL == t_buf){
				fclose(fi);
				printf("܂ (%s)\n", argv[1]);
				exit(1);
			}
			fseek(fi, ofs_tbl[k], SEEK_SET);
			fread(t_buf, 1, t_size, fi);

			sprintf(t_name, "%s_%s.MF1", b_name, typename_tbl[k]);

			fo = fopen(t_name, "wb");
			fwrite(t_buf, 1, t_size, fo);
			fclose(fo);

			free(t_buf);
		}
	}

	fclose(fi);

	printf("ɏI܂ (%s)\n", argv[1]);

	exit(0);
}
